import React, { useEffect, useRef } from "react";
interface Props {
   hideMenu: Function;
   children: any;
}
export default function OutsideClickCatch(props: Props) {
   const menuRef = useRef(null);

   useEffect(() => {
      const handleClickOutside = (event: Event) => {
         if (menuRef.current && !menuRef.current.contains(event.target)) {
            props.hideMenu();
         }
      };
      document.addEventListener("mousedown", handleClickOutside);
      return () => {
         document.removeEventListener("mousedown", handleClickOutside);
      };
   }, [props, props.hideMenu]);

   return <span ref={menuRef}>{props.children}</span>;
}
